/* A Bison parser, made by GNU Bison 2.7.12-4996.  */

/* Bison implementation for Yacc-like parsers in C
   
      Copyright (C) 1984, 1989-1990, 2000-2013 Free Software Foundation, Inc.
   
   This program is free software: you can redistribute it and/or modify
   it under the terms of the GNU General Public License as published by
   the Free Software Foundation, either version 3 of the License, or
   (at your option) any later version.
   
   This program is distributed in the hope that it will be useful,
   but WITHOUT ANY WARRANTY; without even the implied warranty of
   MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
   GNU General Public License for more details.
   
   You should have received a copy of the GNU General Public License
   along with this program.  If not, see <http://www.gnu.org/licenses/>.  */

/* As a special exception, you may create a larger work that contains
   part or all of the Bison parser skeleton and distribute that work
   under terms of your choice, so long as that work isn't itself a
   parser generator using the skeleton or a modified version thereof
   as a parser skeleton.  Alternatively, if you modify or redistribute
   the parser skeleton itself, you may (at your option) remove this
   special exception, which will cause the skeleton and the resulting
   Bison output files to be licensed under the GNU General Public
   License without this special exception.
   
   This special exception was added by the Free Software Foundation in
   version 2.2 of Bison.  */

/* C LALR(1) parser skeleton written by Richard Stallman, by
   simplifying the original so-called "semantic" parser.  */

/* All symbols defined below should begin with yy or YY, to avoid
   infringing on user name space.  This should be done even for local
   variables, as they might otherwise be expanded by user macros.
   There are some unavoidable exceptions within include files to
   define necessary library symbols; they are noted "INFRINGES ON
   USER NAME SPACE" below.  */

/* Identify Bison output.  */
#define YYBISON 1

/* Bison version.  */
#define YYBISON_VERSION "2.7.12-4996"

/* Skeleton name.  */
#define YYSKELETON_NAME "yacc.c"

/* Pure parsers.  */
#define YYPURE 0

/* Push parsers.  */
#define YYPUSH 0

/* Pull parsers.  */
#define YYPULL 1


/* Substitute the variable and function names.  */
#define yyparse         smtlib2parse
#define yylex           smtlib2lex
#define yyerror         smtlib2error
#define yylval          smtlib2lval
#define yychar          smtlib2char
#define yydebug         smtlib2debug
#define yynerrs         smtlib2nerrs

/* Copy the first part of user declarations.  */
/* Line 371 of yacc.c  */
#line 1 "smtlib2.y"

/*****************************************************************************/
/*!
 * \file smtlib2.y
 * 
 * Author: Clark Barrett
 * 
 * Created: Apr 30 2005
 *
 * <hr>
 *
 * License to use, copy, modify, sell and/or distribute this software
 * and its documentation for any purpose is hereby granted without
 * royalty, subject to the terms and conditions defined in the \ref
 * LICENSE file provided with this distribution.
 * 
 * <hr>
 * 
 */
/*****************************************************************************/
/* 
   This file contains the bison code for the parser that reads in CVC
   commands in SMT-LIB language.
*/

#include "vc.h"
#include "parser_exception.h"
#include "parser_temp.h"
#include "translator.h"
#include "kinds.h"
#include "command_line_flags.h"
#include "theory_arith.h"

// Exported shared data
namespace CVC3 {
  extern ParserTemp* parserTemp;
}
// Define shortcuts for various things
#define TMP CVC3::parserTemp
#define EXPR CVC3::parserTemp->expr
#define VC (CVC3::parserTemp->vc)
#define ARRAYSENABLED (CVC3::parserTemp->arrFlag)
#define BVENABLED (CVC3::parserTemp->bvFlag)
#define BVSIZE (CVC3::parserTemp->bvSize)
#define RAT(args) CVC3::newRational args
#define QUERYPARSED CVC3::parserTemp->queryParsed
#define TRANSLATOR CVC3::parserTemp->translator

// Suppress the bogus warning suppression in bison (it generates
// compile error)
#undef __GNUC_MINOR__

/* stuff that lives in smtlib2.lex */
extern int smtlib2lex(void);

int smtlib2error(const char *s)
{
  std::ostringstream ss;
  ss << CVC3::parserTemp->fileName << ":" << CVC3::parserTemp->lineNum
     << ": " << s;
  return CVC3::parserTemp->error(ss.str());
}

#define YYLTYPE_IS_TRIVIAL 1
#define YYMAXDEPTH 10485760

// static hash_map<std::string,std::string> *operators;


/* Line 371 of yacc.c  */
#line 145 "parsesmtlib2.cpp"

# ifndef YY_NULL
#  if defined __cplusplus && 201103L <= __cplusplus
#   define YY_NULL nullptr
#  else
#   define YY_NULL 0
#  endif
# endif

/* Enabling verbose error messages.  */
#ifdef YYERROR_VERBOSE
# undef YYERROR_VERBOSE
# define YYERROR_VERBOSE 1
#else
# define YYERROR_VERBOSE 0
#endif

/* In a future release of Bison, this section will be replaced
   by #include "parsesmtlib2.hpp".  */
#ifndef YY_SMTLIB2_PARSESMTLIB2_HPP_INCLUDED
# define YY_SMTLIB2_PARSESMTLIB2_HPP_INCLUDED
/* Enabling traces.  */
#ifndef YYDEBUG
# define YYDEBUG 1
#endif
#if YYDEBUG
extern int smtlib2debug;
#endif

/* Tokens.  */
#ifndef YYTOKENTYPE
# define YYTOKENTYPE
   /* Put the tokens into the symbol table, so that GDB and other debuggers
      know about them.  */
   enum yytokentype {
     DECIMAL_TOK = 258,
     INTEGER_TOK = 259,
     HEX_TOK = 260,
     BINARY_TOK = 261,
     SYM_TOK = 262,
     KEYWORD_TOK = 263,
     STRING_TOK = 264,
     ASSERT_TOK = 265,
     CHECKSAT_TOK = 266,
     PUSH_TOK = 267,
     POP_TOK = 268,
     DECLARE_FUN_TOK = 269,
     DECLARE_SORT_TOK = 270,
     GET_PROOF_TOK = 271,
     GET_ASSIGNMENT_TOK = 272,
     GET_VALUE_TOK = 273,
     GET_MODEL_TOK = 274,
     EXCLAMATION_TOK = 275,
     EXIT_TOK = 276,
     ITE_TOK = 277,
     LET_TOK = 278,
     LPAREN_TOK = 279,
     RPAREN_TOK = 280,
     SET_LOGIC_TOK = 281,
     SET_INFO_TOK = 282,
     UNDERSCORE_TOK = 283,
     EOF_TOK = 284,
     EXISTS_TOK = 285,
     FORALL_TOK = 286
   };
#endif
/* Tokens.  */
#define DECIMAL_TOK 258
#define INTEGER_TOK 259
#define HEX_TOK 260
#define BINARY_TOK 261
#define SYM_TOK 262
#define KEYWORD_TOK 263
#define STRING_TOK 264
#define ASSERT_TOK 265
#define CHECKSAT_TOK 266
#define PUSH_TOK 267
#define POP_TOK 268
#define DECLARE_FUN_TOK 269
#define DECLARE_SORT_TOK 270
#define GET_PROOF_TOK 271
#define GET_ASSIGNMENT_TOK 272
#define GET_VALUE_TOK 273
#define GET_MODEL_TOK 274
#define EXCLAMATION_TOK 275
#define EXIT_TOK 276
#define ITE_TOK 277
#define LET_TOK 278
#define LPAREN_TOK 279
#define RPAREN_TOK 280
#define SET_LOGIC_TOK 281
#define SET_INFO_TOK 282
#define UNDERSCORE_TOK 283
#define EOF_TOK 284
#define EXISTS_TOK 285
#define FORALL_TOK 286



#if ! defined YYSTYPE && ! defined YYSTYPE_IS_DECLARED
typedef union YYSTYPE
{
/* Line 387 of yacc.c  */
#line 71 "smtlib2.y"

  std::string *str;
  std::vector<std::string> *strvec;
  CVC3::Expr *node;
  std::vector<CVC3::Expr> *vec;
  std::pair<std::vector<CVC3::Expr>, std::vector<CVC3::Expr> > *pat_ann;


/* Line 387 of yacc.c  */
#line 259 "parsesmtlib2.cpp"
} YYSTYPE;
# define YYSTYPE_IS_TRIVIAL 1
# define yystype YYSTYPE /* obsolescent; will be withdrawn */
# define YYSTYPE_IS_DECLARED 1
#endif

extern YYSTYPE smtlib2lval;

#ifdef YYPARSE_PARAM
#if defined __STDC__ || defined __cplusplus
int smtlib2parse (void *YYPARSE_PARAM);
#else
int smtlib2parse ();
#endif
#else /* ! YYPARSE_PARAM */
#if defined __STDC__ || defined __cplusplus
int smtlib2parse (void);
#else
int smtlib2parse ();
#endif
#endif /* ! YYPARSE_PARAM */

#endif /* !YY_SMTLIB2_PARSESMTLIB2_HPP_INCLUDED  */

/* Copy the second part of user declarations.  */

/* Line 390 of yacc.c  */
#line 287 "parsesmtlib2.cpp"

#ifdef short
# undef short
#endif

#ifdef YYTYPE_UINT8
typedef YYTYPE_UINT8 yytype_uint8;
#else
typedef unsigned char yytype_uint8;
#endif

#ifdef YYTYPE_INT8
typedef YYTYPE_INT8 yytype_int8;
#elif (defined __STDC__ || defined __C99__FUNC__ \
     || defined __cplusplus || defined _MSC_VER)
typedef signed char yytype_int8;
#else
typedef short int yytype_int8;
#endif

#ifdef YYTYPE_UINT16
typedef YYTYPE_UINT16 yytype_uint16;
#else
typedef unsigned short int yytype_uint16;
#endif

#ifdef YYTYPE_INT16
typedef YYTYPE_INT16 yytype_int16;
#else
typedef short int yytype_int16;
#endif

#ifndef YYSIZE_T
# ifdef __SIZE_TYPE__
#  define YYSIZE_T __SIZE_TYPE__
# elif defined size_t
#  define YYSIZE_T size_t
# elif ! defined YYSIZE_T && (defined __STDC__ || defined __C99__FUNC__ \
     || defined __cplusplus || defined _MSC_VER)
#  include <stddef.h> /* INFRINGES ON USER NAME SPACE */
#  define YYSIZE_T size_t
# else
#  define YYSIZE_T unsigned int
# endif
#endif

#define YYSIZE_MAXIMUM ((YYSIZE_T) -1)

#ifndef YY_
# if defined YYENABLE_NLS && YYENABLE_NLS
#  if ENABLE_NLS
#   include <libintl.h> /* INFRINGES ON USER NAME SPACE */
#   define YY_(Msgid) dgettext ("bison-runtime", Msgid)
#  endif
# endif
# ifndef YY_
#  define YY_(Msgid) Msgid
# endif
#endif

#ifndef __attribute__
/* This feature is available in gcc versions 2.5 and later.  */
# if (! defined __GNUC__ || __GNUC__ < 2 \
      || (__GNUC__ == 2 && __GNUC_MINOR__ < 5))
#  define __attribute__(Spec) /* empty */
# endif
#endif

/* Suppress unused-variable warnings by "using" E.  */
#if ! defined lint || defined __GNUC__
# define YYUSE(E) ((void) (E))
#else
# define YYUSE(E) /* empty */
#endif


/* Identity function, used to suppress warnings about constant conditions.  */
#ifndef lint
# define YYID(N) (N)
#else
#if (defined __STDC__ || defined __C99__FUNC__ \
     || defined __cplusplus || defined _MSC_VER)
static int
YYID (int yyi)
#else
static int
YYID (yyi)
    int yyi;
#endif
{
  return yyi;
}
#endif

#if ! defined yyoverflow || YYERROR_VERBOSE

/* The parser invokes alloca or malloc; define the necessary symbols.  */

# ifdef YYSTACK_USE_ALLOCA
#  if YYSTACK_USE_ALLOCA
#   ifdef __GNUC__
#    define YYSTACK_ALLOC __builtin_alloca
#   elif defined __BUILTIN_VA_ARG_INCR
#    include <alloca.h> /* INFRINGES ON USER NAME SPACE */
#   elif defined _AIX
#    define YYSTACK_ALLOC __alloca
#   elif defined _MSC_VER
#    include <malloc.h> /* INFRINGES ON USER NAME SPACE */
#    define alloca _alloca
#   else
#    define YYSTACK_ALLOC alloca
#    if ! defined _ALLOCA_H && ! defined EXIT_SUCCESS && (defined __STDC__ || defined __C99__FUNC__ \
     || defined __cplusplus || defined _MSC_VER)
#     include <stdlib.h> /* INFRINGES ON USER NAME SPACE */
      /* Use EXIT_SUCCESS as a witness for stdlib.h.  */
#     ifndef EXIT_SUCCESS
#      define EXIT_SUCCESS 0
#     endif
#    endif
#   endif
#  endif
# endif

# ifdef YYSTACK_ALLOC
   /* Pacify GCC's `empty if-body' warning.  */
#  define YYSTACK_FREE(Ptr) do { /* empty */; } while (YYID (0))
#  ifndef YYSTACK_ALLOC_MAXIMUM
    /* The OS might guarantee only one guard page at the bottom of the stack,
       and a page size can be as small as 4096 bytes.  So we cannot safely
       invoke alloca (N) if N exceeds 4096.  Use a slightly smaller number
       to allow for a few compiler-allocated temporary stack slots.  */
#   define YYSTACK_ALLOC_MAXIMUM 4032 /* reasonable circa 2006 */
#  endif
# else
#  define YYSTACK_ALLOC YYMALLOC
#  define YYSTACK_FREE YYFREE
#  ifndef YYSTACK_ALLOC_MAXIMUM
#   define YYSTACK_ALLOC_MAXIMUM YYSIZE_MAXIMUM
#  endif
#  if (defined __cplusplus && ! defined EXIT_SUCCESS \
       && ! ((defined YYMALLOC || defined malloc) \
	     && (defined YYFREE || defined free)))
#   include <stdlib.h> /* INFRINGES ON USER NAME SPACE */
#   ifndef EXIT_SUCCESS
#    define EXIT_SUCCESS 0
#   endif
#  endif
#  ifndef YYMALLOC
#   define YYMALLOC malloc
#   if ! defined malloc && ! defined EXIT_SUCCESS && (defined __STDC__ || defined __C99__FUNC__ \
     || defined __cplusplus || defined _MSC_VER)
void *malloc (YYSIZE_T); /* INFRINGES ON USER NAME SPACE */
#   endif
#  endif
#  ifndef YYFREE
#   define YYFREE free
#   if ! defined free && ! defined EXIT_SUCCESS && (defined __STDC__ || defined __C99__FUNC__ \
     || defined __cplusplus || defined _MSC_VER)
void free (void *); /* INFRINGES ON USER NAME SPACE */
#   endif
#  endif
# endif
#endif /* ! defined yyoverflow || YYERROR_VERBOSE */


#if (! defined yyoverflow \
     && (! defined __cplusplus \
	 || (defined YYSTYPE_IS_TRIVIAL && YYSTYPE_IS_TRIVIAL)))

/* A type that is properly aligned for any stack member.  */
union yyalloc
{
  yytype_int16 yyss_alloc;
  YYSTYPE yyvs_alloc;
};

/* The size of the maximum gap between one aligned stack and the next.  */
# define YYSTACK_GAP_MAXIMUM (sizeof (union yyalloc) - 1)

/* The size of an array large to enough to hold all stacks, each with
   N elements.  */
# define YYSTACK_BYTES(N) \
     ((N) * (sizeof (yytype_int16) + sizeof (YYSTYPE)) \
      + YYSTACK_GAP_MAXIMUM)

# define YYCOPY_NEEDED 1

/* Relocate STACK from its old location to the new one.  The
   local variables YYSIZE and YYSTACKSIZE give the old and new number of
   elements in the stack, and YYPTR gives the new location of the
   stack.  Advance YYPTR to a properly aligned location for the next
   stack.  */
# define YYSTACK_RELOCATE(Stack_alloc, Stack)				\
    do									\
      {									\
	YYSIZE_T yynewbytes;						\
	YYCOPY (&yyptr->Stack_alloc, Stack, yysize);			\
	Stack = &yyptr->Stack_alloc;					\
	yynewbytes = yystacksize * sizeof (*Stack) + YYSTACK_GAP_MAXIMUM; \
	yyptr += yynewbytes / sizeof (*yyptr);				\
      }									\
    while (YYID (0))

#endif

#if defined YYCOPY_NEEDED && YYCOPY_NEEDED
/* Copy COUNT objects from SRC to DST.  The source and destination do
   not overlap.  */
# ifndef YYCOPY
#  if defined __GNUC__ && 1 < __GNUC__
#   define YYCOPY(Dst, Src, Count) \
      __builtin_memcpy (Dst, Src, (Count) * sizeof (*(Src)))
#  else
#   define YYCOPY(Dst, Src, Count)              \
      do                                        \
        {                                       \
          YYSIZE_T yyi;                         \
          for (yyi = 0; yyi < (Count); yyi++)   \
            (Dst)[yyi] = (Src)[yyi];            \
        }                                       \
      while (YYID (0))
#  endif
# endif
#endif /* !YYCOPY_NEEDED */

/* YYFINAL -- State number of the termination state.  */
#define YYFINAL  18
/* YYLAST -- Last index in YYTABLE.  */
#define YYLAST   139

/* YYNTOKENS -- Number of terminals.  */
#define YYNTOKENS  32
/* YYNNTS -- Number of nonterminals.  */
#define YYNNTS  20
/* YYNRULES -- Number of rules.  */
#define YYNRULES  64
/* YYNRULES -- Number of states.  */
#define YYNSTATES  117

/* YYTRANSLATE(YYLEX) -- Bison symbol number corresponding to YYLEX.  */
#define YYUNDEFTOK  2
#define YYMAXUTOK   286

#define YYTRANSLATE(YYX)						\
  ((unsigned int) (YYX) <= YYMAXUTOK ? yytranslate[YYX] : YYUNDEFTOK)

/* YYTRANSLATE[YYLEX] -- Bison symbol number corresponding to YYLEX.  */
static const yytype_uint8 yytranslate[] =
{
       0,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     1,     2,     3,     4,
       5,     6,     7,     8,     9,    10,    11,    12,    13,    14,
      15,    16,    17,    18,    19,    20,    21,    22,    23,    24,
      25,    26,    27,    28,    29,    30,    31
};

#if YYDEBUG
/* YYPRHS[YYN] -- Index of the first RHS symbol of rule number YYN in
   YYRHS.  */
static const yytype_uint8 yyprhs[] =
{
       0,     0,     3,     7,     9,    12,    16,    20,    27,    30,
      32,    35,    38,    40,    42,    47,    49,    51,    53,    56,
      58,    60,    62,    64,    68,    70,    72,    73,    75,    77,
      80,    82,    87,    89,    95,    97,   100,   102,   105,   110,
     118,   126,   132,   134,   136,   138,   140,   142,   144,   146,
     148,   151,   156,   158,   161,   166,   168,   171,   173,   176,
     179,   182,   185,   188,   191
};

/* YYRHS -- A `-1'-separated list of the rules' RHS.  */
static const yytype_int8 yyrhs[] =
{
      33,     0,    -1,    24,    34,    25,    -1,    29,    -1,    26,
       7,    -1,    27,     8,    37,    -1,    15,     7,     4,    -1,
      14,     7,    24,    38,    25,    40,    -1,    10,    44,    -1,
      11,    -1,    12,     4,    -1,    13,     4,    -1,    16,    -1,
      17,    -1,    18,    24,    43,    25,    -1,    19,    -1,    21,
      -1,    37,    -1,    35,    37,    -1,     4,    -1,     3,    -1,
       9,    -1,     7,    -1,    24,    35,    25,    -1,    36,    -1,
       8,    -1,    -1,    39,    -1,    40,    -1,    38,    40,    -1,
      41,    -1,    24,    41,    39,    25,    -1,     7,    -1,    24,
      28,     7,    42,    25,    -1,     4,    -1,    42,     4,    -1,
      44,    -1,    43,    44,    -1,    24,    41,    43,    25,    -1,
      24,    23,    24,    46,    25,    44,    25,    -1,    24,    45,
      24,    48,    25,    44,    25,    -1,    24,    20,    44,    50,
      25,    -1,    41,    -1,     3,    -1,     4,    -1,     5,    -1,
       6,    -1,    30,    -1,    31,    -1,    47,    -1,    46,    47,
      -1,    24,     7,    44,    25,    -1,    49,    -1,    48,    49,
      -1,    24,     7,    40,    25,    -1,    51,    -1,    50,    51,
      -1,     8,    -1,     8,     7,    -1,     8,     4,    -1,     8,
       3,    -1,     8,     5,    -1,     8,     6,    -1,     8,     9,
      -1,     8,    24,    43,    25,    -1
};

/* YYRLINE[YYN] -- source line where rule number YYN was defined.  */
static const yytype_uint16 yyrline[] =
{
       0,   146,   146,   152,   161,   242,   275,   281,   296,   302,
     308,   313,   318,   323,   328,   334,   339,   347,   353,   365,
     368,   378,   381,   384,   390,   394,   401,   404,   411,   417,
     426,   441,   460,   569,   607,   613,   623,   630,   639,   704,
     712,   739,   748,   753,   764,   770,   780,   947,   951,   960,
     966,   975,   983,   989,   998,  1008,  1014,  1023,  1029,  1036,
    1043,  1050,  1057,  1064,  1071
};
#endif

#if YYDEBUG || YYERROR_VERBOSE || 0
/* YYTNAME[SYMBOL-NUM] -- String name of the symbol SYMBOL-NUM.
   First, the terminals, then, starting at YYNTOKENS, nonterminals.  */
static const char *const yytname[] =
{
  "$end", "error", "$undefined", "DECIMAL_TOK", "INTEGER_TOK", "HEX_TOK",
  "BINARY_TOK", "SYM_TOK", "KEYWORD_TOK", "STRING_TOK", "ASSERT_TOK",
  "CHECKSAT_TOK", "PUSH_TOK", "POP_TOK", "DECLARE_FUN_TOK",
  "DECLARE_SORT_TOK", "GET_PROOF_TOK", "GET_ASSIGNMENT_TOK",
  "GET_VALUE_TOK", "GET_MODEL_TOK", "EXCLAMATION_TOK", "EXIT_TOK",
  "ITE_TOK", "LET_TOK", "LPAREN_TOK", "RPAREN_TOK", "SET_LOGIC_TOK",
  "SET_INFO_TOK", "UNDERSCORE_TOK", "EOF_TOK", "EXISTS_TOK", "FORALL_TOK",
  "$accept", "command", "command_aux", "sexprs", "non_keyword_sexpr",
  "sexpr", "sort_symbols", "sort_symbols_nonempty", "sort_symbol",
  "identifier", "numerals", "terms", "term", "quantifier", "bindings",
  "binding", "sorted_vars", "sorted_var", "attributes", "attribute", YY_NULL
};
#endif

# ifdef YYPRINT
/* YYTOKNUM[YYLEX-NUM] -- Internal token number corresponding to
   token YYLEX-NUM.  */
static const yytype_uint16 yytoknum[] =
{
       0,   256,   257,   258,   259,   260,   261,   262,   263,   264,
     265,   266,   267,   268,   269,   270,   271,   272,   273,   274,
     275,   276,   277,   278,   279,   280,   281,   282,   283,   284,
     285,   286
};
# endif

/* YYR1[YYN] -- Symbol number of symbol that rule YYN derives.  */
static const yytype_uint8 yyr1[] =
{
       0,    32,    33,    33,    34,    34,    34,    34,    34,    34,
      34,    34,    34,    34,    34,    34,    34,    35,    35,    36,
      36,    36,    36,    36,    37,    37,    38,    38,    39,    39,
      40,    40,    41,    41,    42,    42,    43,    43,    44,    44,
      44,    44,    44,    44,    44,    44,    44,    45,    45,    46,
      46,    47,    48,    48,    49,    50,    50,    51,    51,    51,
      51,    51,    51,    51,    51
};

/* YYR2[YYN] -- Number of symbols composing right hand side of rule YYN.  */
static const yytype_uint8 yyr2[] =
{
       0,     2,     3,     1,     2,     3,     3,     6,     2,     1,
       2,     2,     1,     1,     4,     1,     1,     1,     2,     1,
       1,     1,     1,     3,     1,     1,     0,     1,     1,     2,
       1,     4,     1,     5,     1,     2,     1,     2,     4,     7,
       7,     5,     1,     1,     1,     1,     1,     1,     1,     1,
       2,     4,     1,     2,     4,     1,     2,     1,     2,     2,
       2,     2,     2,     2,     4
};

/* YYDEFACT[STATE-NAME] -- Default reduction number in state STATE-NUM.
   Performed when YYTABLE doesn't specify something else to do.  Zero
   means the default is an error.  */
static const yytype_uint8 yydefact[] =
{
       0,     0,     3,     0,     0,     9,     0,     0,     0,     0,
      12,    13,     0,    15,    16,     0,     0,     0,     1,    43,
      44,    45,    46,    32,     0,    42,     8,    10,    11,     0,
       0,     0,     4,     0,     2,     0,     0,     0,     0,    47,
      48,     0,     0,    26,     6,     0,    36,    20,    19,    22,
      25,    21,     0,    24,     5,     0,     0,     0,     0,     0,
       0,     0,    27,    28,    30,    14,    37,     0,    17,    57,
       0,    55,     0,     0,    49,    34,     0,    38,     0,     0,
      52,     0,     0,    29,    23,    18,    60,    59,    61,    62,
      58,    63,     0,    41,    56,     0,     0,    50,    35,    33,
       0,     0,    53,     0,    27,     7,     0,     0,     0,     0,
       0,    31,    64,    51,    39,    54,    40
};

/* YYDEFGOTO[NTERM-NUM].  */
static const yytype_int8 yydefgoto[] =
{
      -1,     3,    17,    67,    53,    54,    61,    62,    63,    25,
      76,    45,    46,    42,    73,    74,    79,    80,    70,    71
};

/* YYPACT[STATE-NUM] -- Index in YYTABLE of the portion describing
   STATE-NUM.  */
#define YYPACT_NINF -59
static const yytype_int8 yypact[] =
{
      15,    95,   -59,    16,     3,   -59,    19,    26,    36,    67,
     -59,   -59,    54,   -59,   -59,    72,    88,    76,   -59,   -59,
     -59,   -59,   -59,   -59,    -2,   -59,   -59,   -59,   -59,    79,
     113,     3,   -59,    91,   -59,     3,    94,    92,   112,   -59,
     -59,     3,    99,    64,   -59,     8,   -59,   -59,   -59,   -59,
     -59,   -59,    91,   -59,   -59,   116,   101,   122,    43,   103,
      12,    10,   -59,   -59,   -59,   -59,   -59,    48,   -59,    80,
      68,   -59,   121,    41,   -59,   -59,     0,   -59,   123,    45,
     -59,    64,    64,   -59,   -59,   -59,   -59,   -59,   -59,   -59,
     -59,   -59,     3,   -59,   -59,     3,     3,   -59,   -59,   -59,
      64,     3,   -59,    64,   104,   -59,    57,   106,   107,   108,
     109,   -59,   -59,   -59,   -59,   -59,   -59
};

/* YYPGOTO[NTERM-NUM].  */
static const yytype_int8 yypgoto[] =
{
     -59,   -59,   -59,   -59,   -59,    23,    55,    56,   -58,   -23,
     -59,   -39,    -4,   -59,   -59,    62,   -59,    59,   -59,    69
};

/* YYTABLE[YYPACT[STATE-NUM]].  What to do in state STATE-NUM.  If
   positive, shift that token.  If negative, reduce the rule which
   number is the opposite.  If YYTABLE_NINF, syntax error.  */
#define YYTABLE_NINF -1
static const yytype_uint8 yytable[] =
{
      26,    41,    58,    83,    98,    23,    19,    20,    21,    22,
      23,    19,    20,    21,    22,    23,    18,    23,    35,    23,
      64,    36,    37,    27,   105,    99,    38,    24,    39,    40,
      28,    55,    24,    65,    60,    82,    37,    81,    64,     1,
      38,    66,   109,    29,     2,    83,    19,    20,    21,    22,
      23,    47,    48,   106,    66,    49,    50,    51,    64,    64,
      19,    20,    21,    22,    23,    72,    96,    24,    77,    78,
     101,    23,    52,    84,    30,    68,    69,    64,    31,    32,
      64,    24,   112,    86,    87,    88,    89,    90,    60,    91,
      85,   107,   108,    93,    47,    48,    33,   110,    49,    50,
      51,    34,    66,    43,    92,     4,     5,     6,     7,     8,
       9,    10,    11,    12,    13,    52,    14,    44,    56,    57,
      38,    15,    16,    59,    69,    72,    75,    78,    95,   111,
     100,   113,   114,   115,   116,    97,   103,   104,   102,    94
};

#define yypact_value_is_default(Yystate) \
  (!!((Yystate) == (-59)))

#define yytable_value_is_error(Yytable_value) \
  YYID (0)

static const yytype_uint8 yycheck[] =
{
       4,    24,    41,    61,     4,     7,     3,     4,     5,     6,
       7,     3,     4,     5,     6,     7,     0,     7,    20,     7,
      43,    23,    24,     4,    82,    25,    28,    24,    30,    31,
       4,    35,    24,    25,    24,    25,    24,    60,    61,    24,
      28,    45,   100,     7,    29,   103,     3,     4,     5,     6,
       7,     3,     4,    92,    58,     7,     8,     9,    81,    82,
       3,     4,     5,     6,     7,    24,    25,    24,    25,    24,
      25,     7,    24,    25,     7,    52,     8,   100,    24,     7,
     103,    24,    25,     3,     4,     5,     6,     7,    24,     9,
      67,    95,    96,    25,     3,     4,     8,   101,     7,     8,
       9,    25,   106,    24,    24,    10,    11,    12,    13,    14,
      15,    16,    17,    18,    19,    24,    21,     4,    24,     7,
      28,    26,    27,    24,     8,    24,     4,    24,     7,    25,
       7,    25,    25,    25,    25,    73,    81,    81,    79,    70
};

/* YYSTOS[STATE-NUM] -- The (internal number of the) accessing
   symbol of state STATE-NUM.  */
static const yytype_uint8 yystos[] =
{
       0,    24,    29,    33,    10,    11,    12,    13,    14,    15,
      16,    17,    18,    19,    21,    26,    27,    34,     0,     3,
       4,     5,     6,     7,    24,    41,    44,     4,     4,     7,
       7,    24,     7,     8,    25,    20,    23,    24,    28,    30,
      31,    41,    45,    24,     4,    43,    44,     3,     4,     7,
       8,     9,    24,    36,    37,    44,    24,     7,    43,    24,
      24,    38,    39,    40,    41,    25,    44,    35,    37,     8,
      50,    51,    24,    46,    47,     4,    42,    25,    24,    48,
      49,    41,    25,    40,    25,    37,     3,     4,     5,     6,
       7,     9,    24,    25,    51,     7,    25,    47,     4,    25,
       7,    25,    49,    38,    39,    40,    43,    44,    44,    40,
      44,    25,    25,    25,    25,    25,    25
};

#define yyerrok		(yyerrstatus = 0)
#define yyclearin	(yychar = YYEMPTY)
#define YYEMPTY		(-2)
#define YYEOF		0

#define YYACCEPT	goto yyacceptlab
#define YYABORT		goto yyabortlab
#define YYERROR		goto yyerrorlab


/* Like YYERROR except do call yyerror.  This remains here temporarily
   to ease the transition to the new meaning of YYERROR, for GCC.
   Once GCC version 2 has supplanted version 1, this can go.  However,
   YYFAIL appears to be in use.  Nevertheless, it is formally deprecated
   in Bison 2.4.2's NEWS entry, where a plan to phase it out is
   discussed.  */

#define YYFAIL		goto yyerrlab
#if defined YYFAIL
  /* This is here to suppress warnings from the GCC cpp's
     -Wunused-macros.  Normally we don't worry about that warning, but
     some users do, and we want to make it easy for users to remove
     YYFAIL uses, which will produce warnings from Bison 2.5.  */
#endif

#define YYRECOVERING()  (!!yyerrstatus)

#define YYBACKUP(Token, Value)                                  \
do                                                              \
  if (yychar == YYEMPTY)                                        \
    {                                                           \
      yychar = (Token);                                         \
      yylval = (Value);                                         \
      YYPOPSTACK (yylen);                                       \
      yystate = *yyssp;                                         \
      goto yybackup;                                            \
    }                                                           \
  else                                                          \
    {                                                           \
      yyerror (YY_("syntax error: cannot back up")); \
      YYERROR;							\
    }								\
while (YYID (0))

/* Error token number */
#define YYTERROR	1
#define YYERRCODE	256


/* This macro is provided for backward compatibility. */
#ifndef YY_LOCATION_PRINT
# define YY_LOCATION_PRINT(File, Loc) ((void) 0)
#endif


/* YYLEX -- calling `yylex' with the right arguments.  */
#ifdef YYLEX_PARAM
# define YYLEX yylex (YYLEX_PARAM)
#else
# define YYLEX yylex ()
#endif

/* Enable debugging if requested.  */
#if YYDEBUG

# ifndef YYFPRINTF
#  include <stdio.h> /* INFRINGES ON USER NAME SPACE */
#  define YYFPRINTF fprintf
# endif

# define YYDPRINTF(Args)			\
do {						\
  if (yydebug)					\
    YYFPRINTF Args;				\
} while (YYID (0))

# define YY_SYMBOL_PRINT(Title, Type, Value, Location)			  \
do {									  \
  if (yydebug)								  \
    {									  \
      YYFPRINTF (stderr, "%s ", Title);					  \
      yy_symbol_print (stderr,						  \
		  Type, Value); \
      YYFPRINTF (stderr, "\n");						  \
    }									  \
} while (YYID (0))


/*--------------------------------.
| Print this symbol on YYOUTPUT.  |
`--------------------------------*/

/*ARGSUSED*/
#if (defined __STDC__ || defined __C99__FUNC__ \
     || defined __cplusplus || defined _MSC_VER)
static void
yy_symbol_value_print (FILE *yyoutput, int yytype, YYSTYPE const * const yyvaluep)
#else
static void
yy_symbol_value_print (yyoutput, yytype, yyvaluep)
    FILE *yyoutput;
    int yytype;
    YYSTYPE const * const yyvaluep;
#endif
{
  FILE *yyo = yyoutput;
  YYUSE (yyo);
  if (!yyvaluep)
    return;
# ifdef YYPRINT
  if (yytype < YYNTOKENS)
    YYPRINT (yyoutput, yytoknum[yytype], *yyvaluep);
# else
  YYUSE (yyoutput);
# endif
  YYUSE (yytype);
}


/*--------------------------------.
| Print this symbol on YYOUTPUT.  |
`--------------------------------*/

#if (defined __STDC__ || defined __C99__FUNC__ \
     || defined __cplusplus || defined _MSC_VER)
static void
yy_symbol_print (FILE *yyoutput, int yytype, YYSTYPE const * const yyvaluep)
#else
static void
yy_symbol_print (yyoutput, yytype, yyvaluep)
    FILE *yyoutput;
    int yytype;
    YYSTYPE const * const yyvaluep;
#endif
{
  if (yytype < YYNTOKENS)
    YYFPRINTF (yyoutput, "token %s (", yytname[yytype]);
  else
    YYFPRINTF (yyoutput, "nterm %s (", yytname[yytype]);

  yy_symbol_value_print (yyoutput, yytype, yyvaluep);
  YYFPRINTF (yyoutput, ")");
}

/*------------------------------------------------------------------.
| yy_stack_print -- Print the state stack from its BOTTOM up to its |
| TOP (included).                                                   |
`------------------------------------------------------------------*/

#if (defined __STDC__ || defined __C99__FUNC__ \
     || defined __cplusplus || defined _MSC_VER)
static void
yy_stack_print (yytype_int16 *yybottom, yytype_int16 *yytop)
#else
static void
yy_stack_print (yybottom, yytop)
    yytype_int16 *yybottom;
    yytype_int16 *yytop;
#endif
{
  YYFPRINTF (stderr, "Stack now");
  for (; yybottom <= yytop; yybottom++)
    {
      int yybot = *yybottom;
      YYFPRINTF (stderr, " %d", yybot);
    }
  YYFPRINTF (stderr, "\n");
}

# define YY_STACK_PRINT(Bottom, Top)				\
do {								\
  if (yydebug)							\
    yy_stack_print ((Bottom), (Top));				\
} while (YYID (0))


/*------------------------------------------------.
| Report that the YYRULE is going to be reduced.  |
`------------------------------------------------*/

#if (defined __STDC__ || defined __C99__FUNC__ \
     || defined __cplusplus || defined _MSC_VER)
static void
yy_reduce_print (YYSTYPE *yyvsp, int yyrule)
#else
static void
yy_reduce_print (yyvsp, yyrule)
    YYSTYPE *yyvsp;
    int yyrule;
#endif
{
  int yynrhs = yyr2[yyrule];
  int yyi;
  unsigned long int yylno = yyrline[yyrule];
  YYFPRINTF (stderr, "Reducing stack by rule %d (line %lu):\n",
	     yyrule - 1, yylno);
  /* The symbols being reduced.  */
  for (yyi = 0; yyi < yynrhs; yyi++)
    {
      YYFPRINTF (stderr, "   $%d = ", yyi + 1);
      yy_symbol_print (stderr, yyrhs[yyprhs[yyrule] + yyi],
		       &(yyvsp[(yyi + 1) - (yynrhs)])
		       		       );
      YYFPRINTF (stderr, "\n");
    }
}

# define YY_REDUCE_PRINT(Rule)		\
do {					\
  if (yydebug)				\
    yy_reduce_print (yyvsp, Rule); \
} while (YYID (0))

/* Nonzero means print parse trace.  It is left uninitialized so that
   multiple parsers can coexist.  */
int yydebug;
#else /* !YYDEBUG */
# define YYDPRINTF(Args)
# define YY_SYMBOL_PRINT(Title, Type, Value, Location)
# define YY_STACK_PRINT(Bottom, Top)
# define YY_REDUCE_PRINT(Rule)
#endif /* !YYDEBUG */


/* YYINITDEPTH -- initial size of the parser's stacks.  */
#ifndef	YYINITDEPTH
# define YYINITDEPTH 200
#endif

/* YYMAXDEPTH -- maximum size the stacks can grow to (effective only
   if the built-in stack extension method is used).

   Do not make this value too large; the results are undefined if
   YYSTACK_ALLOC_MAXIMUM < YYSTACK_BYTES (YYMAXDEPTH)
   evaluated with infinite-precision integer arithmetic.  */

#ifndef YYMAXDEPTH
# define YYMAXDEPTH 10000
#endif


#if YYERROR_VERBOSE

# ifndef yystrlen
#  if defined __GLIBC__ && defined _STRING_H
#   define yystrlen strlen
#  else
/* Return the length of YYSTR.  */
#if (defined __STDC__ || defined __C99__FUNC__ \
     || defined __cplusplus || defined _MSC_VER)
static YYSIZE_T
yystrlen (const char *yystr)
#else
static YYSIZE_T
yystrlen (yystr)
    const char *yystr;
#endif
{
  YYSIZE_T yylen;
  for (yylen = 0; yystr[yylen]; yylen++)
    continue;
  return yylen;
}
#  endif
# endif

# ifndef yystpcpy
#  if defined __GLIBC__ && defined _STRING_H && defined _GNU_SOURCE
#   define yystpcpy stpcpy
#  else
/* Copy YYSRC to YYDEST, returning the address of the terminating '\0' in
   YYDEST.  */
#if (defined __STDC__ || defined __C99__FUNC__ \
     || defined __cplusplus || defined _MSC_VER)
static char *
yystpcpy (char *yydest, const char *yysrc)
#else
static char *
yystpcpy (yydest, yysrc)
    char *yydest;
    const char *yysrc;
#endif
{
  char *yyd = yydest;
  const char *yys = yysrc;

  while ((*yyd++ = *yys++) != '\0')
    continue;

  return yyd - 1;
}
#  endif
# endif

# ifndef yytnamerr
/* Copy to YYRES the contents of YYSTR after stripping away unnecessary
   quotes and backslashes, so that it's suitable for yyerror.  The
   heuristic is that double-quoting is unnecessary unless the string
   contains an apostrophe, a comma, or backslash (other than
   backslash-backslash).  YYSTR is taken from yytname.  If YYRES is
   null, do not copy; instead, return the length of what the result
   would have been.  */
static YYSIZE_T
yytnamerr (char *yyres, const char *yystr)
{
  if (*yystr == '"')
    {
      YYSIZE_T yyn = 0;
      char const *yyp = yystr;

      for (;;)
	switch (*++yyp)
	  {
	  case '\'':
	  case ',':
	    goto do_not_strip_quotes;

	  case '\\':
	    if (*++yyp != '\\')
	      goto do_not_strip_quotes;
	    /* Fall through.  */
	  default:
	    if (yyres)
	      yyres[yyn] = *yyp;
	    yyn++;
	    break;

	  case '"':
	    if (yyres)
	      yyres[yyn] = '\0';
	    return yyn;
	  }
    do_not_strip_quotes: ;
    }

  if (! yyres)
    return yystrlen (yystr);

  return yystpcpy (yyres, yystr) - yyres;
}
# endif

/* Copy into *YYMSG, which is of size *YYMSG_ALLOC, an error message
   about the unexpected token YYTOKEN for the state stack whose top is
   YYSSP.

   Return 0 if *YYMSG was successfully written.  Return 1 if *YYMSG is
   not large enough to hold the message.  In that case, also set
   *YYMSG_ALLOC to the required number of bytes.  Return 2 if the
   required number of bytes is too large to store.  */
static int
yysyntax_error (YYSIZE_T *yymsg_alloc, char **yymsg,
                yytype_int16 *yyssp, int yytoken)
{
  YYSIZE_T yysize0 = yytnamerr (YY_NULL, yytname[yytoken]);
  YYSIZE_T yysize = yysize0;
  enum { YYERROR_VERBOSE_ARGS_MAXIMUM = 5 };
  /* Internationalized format string. */
  const char *yyformat = YY_NULL;
  /* Arguments of yyformat. */
  char const *yyarg[YYERROR_VERBOSE_ARGS_MAXIMUM];
  /* Number of reported tokens (one for the "unexpected", one per
     "expected"). */
  int yycount = 0;

  /* There are many possibilities here to consider:
     - Assume YYFAIL is not used.  It's too flawed to consider.  See
       <http://lists.gnu.org/archive/html/bison-patches/2009-12/msg00024.html>
       for details.  YYERROR is fine as it does not invoke this
       function.
     - If this state is a consistent state with a default action, then
       the only way this function was invoked is if the default action
       is an error action.  In that case, don't check for expected
       tokens because there are none.
     - The only way there can be no lookahead present (in yychar) is if
       this state is a consistent state with a default action.  Thus,
       detecting the absence of a lookahead is sufficient to determine
       that there is no unexpected or expected token to report.  In that
       case, just report a simple "syntax error".
     - Don't assume there isn't a lookahead just because this state is a
       consistent state with a default action.  There might have been a
       previous inconsistent state, consistent state with a non-default
       action, or user semantic action that manipulated yychar.
     - Of course, the expected token list depends on states to have
       correct lookahead information, and it depends on the parser not
       to perform extra reductions after fetching a lookahead from the
       scanner and before detecting a syntax error.  Thus, state merging
       (from LALR or IELR) and default reductions corrupt the expected
       token list.  However, the list is correct for canonical LR with
       one exception: it will still contain any token that will not be
       accepted due to an error action in a later state.
  */
  if (yytoken != YYEMPTY)
    {
      int yyn = yypact[*yyssp];
      yyarg[yycount++] = yytname[yytoken];
      if (!yypact_value_is_default (yyn))
        {
          /* Start YYX at -YYN if negative to avoid negative indexes in
             YYCHECK.  In other words, skip the first -YYN actions for
             this state because they are default actions.  */
          int yyxbegin = yyn < 0 ? -yyn : 0;
          /* Stay within bounds of both yycheck and yytname.  */
          int yychecklim = YYLAST - yyn + 1;
          int yyxend = yychecklim < YYNTOKENS ? yychecklim : YYNTOKENS;
          int yyx;

          for (yyx = yyxbegin; yyx < yyxend; ++yyx)
            if (yycheck[yyx + yyn] == yyx && yyx != YYTERROR
                && !yytable_value_is_error (yytable[yyx + yyn]))
              {
                if (yycount == YYERROR_VERBOSE_ARGS_MAXIMUM)
                  {
                    yycount = 1;
                    yysize = yysize0;
                    break;
                  }
                yyarg[yycount++] = yytname[yyx];
                {
                  YYSIZE_T yysize1 = yysize + yytnamerr (YY_NULL, yytname[yyx]);
                  if (! (yysize <= yysize1
                         && yysize1 <= YYSTACK_ALLOC_MAXIMUM))
                    return 2;
                  yysize = yysize1;
                }
              }
        }
    }

  switch (yycount)
    {
# define YYCASE_(N, S)                      \
      case N:                               \
        yyformat = S;                       \
      break
      YYCASE_(0, YY_("syntax error"));
      YYCASE_(1, YY_("syntax error, unexpected %s"));
      YYCASE_(2, YY_("syntax error, unexpected %s, expecting %s"));
      YYCASE_(3, YY_("syntax error, unexpected %s, expecting %s or %s"));
      YYCASE_(4, YY_("syntax error, unexpected %s, expecting %s or %s or %s"));
      YYCASE_(5, YY_("syntax error, unexpected %s, expecting %s or %s or %s or %s"));
# undef YYCASE_
    }

  {
    YYSIZE_T yysize1 = yysize + yystrlen (yyformat);
    if (! (yysize <= yysize1 && yysize1 <= YYSTACK_ALLOC_MAXIMUM))
      return 2;
    yysize = yysize1;
  }

  if (*yymsg_alloc < yysize)
    {
      *yymsg_alloc = 2 * yysize;
      if (! (yysize <= *yymsg_alloc
             && *yymsg_alloc <= YYSTACK_ALLOC_MAXIMUM))
        *yymsg_alloc = YYSTACK_ALLOC_MAXIMUM;
      return 1;
    }

  /* Avoid sprintf, as that infringes on the user's name space.
     Don't have undefined behavior even if the translation
     produced a string with the wrong number of "%s"s.  */
  {
    char *yyp = *yymsg;
    int yyi = 0;
    while ((*yyp = *yyformat) != '\0')
      if (*yyp == '%' && yyformat[1] == 's' && yyi < yycount)
        {
          yyp += yytnamerr (yyp, yyarg[yyi++]);
          yyformat += 2;
        }
      else
        {
          yyp++;
          yyformat++;
        }
  }
  return 0;
}
#endif /* YYERROR_VERBOSE */

/*-----------------------------------------------.
| Release the memory associated to this symbol.  |
`-----------------------------------------------*/

/*ARGSUSED*/
#if (defined __STDC__ || defined __C99__FUNC__ \
     || defined __cplusplus || defined _MSC_VER)
static void
yydestruct (const char *yymsg, int yytype, YYSTYPE *yyvaluep)
#else
static void
yydestruct (yymsg, yytype, yyvaluep)
    const char *yymsg;
    int yytype;
    YYSTYPE *yyvaluep;
#endif
{
  YYUSE (yyvaluep);

  if (!yymsg)
    yymsg = "Deleting";
  YY_SYMBOL_PRINT (yymsg, yytype, yyvaluep, yylocationp);

  YYUSE (yytype);
}




/* The lookahead symbol.  */
int yychar;


#ifndef YY_IGNORE_MAYBE_UNINITIALIZED_BEGIN
# define YY_IGNORE_MAYBE_UNINITIALIZED_BEGIN
# define YY_IGNORE_MAYBE_UNINITIALIZED_END
#endif
#ifndef YY_INITIAL_VALUE
# define YY_INITIAL_VALUE(Value) /* Nothing. */
#endif

/* The semantic value of the lookahead symbol.  */
YYSTYPE yylval YY_INITIAL_VALUE(yyval_default);

/* Number of syntax errors so far.  */
int yynerrs;


/*----------.
| yyparse.  |
`----------*/

#ifdef YYPARSE_PARAM
#if (defined __STDC__ || defined __C99__FUNC__ \
     || defined __cplusplus || defined _MSC_VER)
int
yyparse (void *YYPARSE_PARAM)
#else
int
yyparse (YYPARSE_PARAM)
    void *YYPARSE_PARAM;
#endif
#else /* ! YYPARSE_PARAM */
#if (defined __STDC__ || defined __C99__FUNC__ \
     || defined __cplusplus || defined _MSC_VER)
int
yyparse (void)
#else
int
yyparse ()

#endif
#endif
{
    int yystate;
    /* Number of tokens to shift before error messages enabled.  */
    int yyerrstatus;

    /* The stacks and their tools:
       `yyss': related to states.
       `yyvs': related to semantic values.

       Refer to the stacks through separate pointers, to allow yyoverflow
       to reallocate them elsewhere.  */

    /* The state stack.  */
    yytype_int16 yyssa[YYINITDEPTH];
    yytype_int16 *yyss;
    yytype_int16 *yyssp;

    /* The semantic value stack.  */
    YYSTYPE yyvsa[YYINITDEPTH];
    YYSTYPE *yyvs;
    YYSTYPE *yyvsp;

    YYSIZE_T yystacksize;

  int yyn;
  int yyresult;
  /* Lookahead token as an internal (translated) token number.  */
  int yytoken = 0;
  /* The variables used to return semantic value and location from the
     action routines.  */
  YYSTYPE yyval;

#if YYERROR_VERBOSE
  /* Buffer for error messages, and its allocated size.  */
  char yymsgbuf[128];
  char *yymsg = yymsgbuf;
  YYSIZE_T yymsg_alloc = sizeof yymsgbuf;
#endif

#define YYPOPSTACK(N)   (yyvsp -= (N), yyssp -= (N))

  /* The number of symbols on the RHS of the reduced rule.
     Keep to zero when no symbol should be popped.  */
  int yylen = 0;

  yyssp = yyss = yyssa;
  yyvsp = yyvs = yyvsa;
  yystacksize = YYINITDEPTH;

  YYDPRINTF ((stderr, "Starting parse\n"));

  yystate = 0;
  yyerrstatus = 0;
  yynerrs = 0;
  yychar = YYEMPTY; /* Cause a token to be read.  */
  goto yysetstate;

/*------------------------------------------------------------.
| yynewstate -- Push a new state, which is found in yystate.  |
`------------------------------------------------------------*/
 yynewstate:
  /* In all cases, when you get here, the value and location stacks
     have just been pushed.  So pushing a state here evens the stacks.  */
  yyssp++;

 yysetstate:
  *yyssp = yystate;

  if (yyss + yystacksize - 1 <= yyssp)
    {
      /* Get the current used size of the three stacks, in elements.  */
      YYSIZE_T yysize = yyssp - yyss + 1;

#ifdef yyoverflow
      {
	/* Give user a chance to reallocate the stack.  Use copies of
	   these so that the &'s don't force the real ones into
	   memory.  */
	YYSTYPE *yyvs1 = yyvs;
	yytype_int16 *yyss1 = yyss;

	/* Each stack pointer address is followed by the size of the
	   data in use in that stack, in bytes.  This used to be a
	   conditional around just the two extra args, but that might
	   be undefined if yyoverflow is a macro.  */
	yyoverflow (YY_("memory exhausted"),
		    &yyss1, yysize * sizeof (*yyssp),
		    &yyvs1, yysize * sizeof (*yyvsp),
		    &yystacksize);

	yyss = yyss1;
	yyvs = yyvs1;
      }
#else /* no yyoverflow */
# ifndef YYSTACK_RELOCATE
      goto yyexhaustedlab;
# else
      /* Extend the stack our own way.  */
      if (YYMAXDEPTH <= yystacksize)
	goto yyexhaustedlab;
      yystacksize *= 2;
      if (YYMAXDEPTH < yystacksize)
	yystacksize = YYMAXDEPTH;

      {
	yytype_int16 *yyss1 = yyss;
	union yyalloc *yyptr =
	  (union yyalloc *) YYSTACK_ALLOC (YYSTACK_BYTES (yystacksize));
	if (! yyptr)
	  goto yyexhaustedlab;
	YYSTACK_RELOCATE (yyss_alloc, yyss);
	YYSTACK_RELOCATE (yyvs_alloc, yyvs);
#  undef YYSTACK_RELOCATE
	if (yyss1 != yyssa)
	  YYSTACK_FREE (yyss1);
      }
# endif
#endif /* no yyoverflow */

      yyssp = yyss + yysize - 1;
      yyvsp = yyvs + yysize - 1;

      YYDPRINTF ((stderr, "Stack size increased to %lu\n",
		  (unsigned long int) yystacksize));

      if (yyss + yystacksize - 1 <= yyssp)
	YYABORT;
    }

  YYDPRINTF ((stderr, "Entering state %d\n", yystate));

  if (yystate == YYFINAL)
    YYACCEPT;

  goto yybackup;

/*-----------.
| yybackup.  |
`-----------*/
yybackup:

  /* Do appropriate processing given the current state.  Read a
     lookahead token if we need one and don't already have one.  */

  /* First try to decide what to do without reference to lookahead token.  */
  yyn = yypact[yystate];
  if (yypact_value_is_default (yyn))
    goto yydefault;

  /* Not known => get a lookahead token if don't already have one.  */

  /* YYCHAR is either YYEMPTY or YYEOF or a valid lookahead symbol.  */
  if (yychar == YYEMPTY)
    {
      YYDPRINTF ((stderr, "Reading a token: "));
      yychar = YYLEX;
    }

  if (yychar <= YYEOF)
    {
      yychar = yytoken = YYEOF;
      YYDPRINTF ((stderr, "Now at end of input.\n"));
    }
  else
    {
      yytoken = YYTRANSLATE (yychar);
      YY_SYMBOL_PRINT ("Next token is", yytoken, &yylval, &yylloc);
    }

  /* If the proper action on seeing token YYTOKEN is to reduce or to
     detect an error, take that action.  */
  yyn += yytoken;
  if (yyn < 0 || YYLAST < yyn || yycheck[yyn] != yytoken)
    goto yydefault;
  yyn = yytable[yyn];
  if (yyn <= 0)
    {
      if (yytable_value_is_error (yyn))
        goto yyerrlab;
      yyn = -yyn;
      goto yyreduce;
    }

  /* Count tokens shifted since error; after three, turn off error
     status.  */
  if (yyerrstatus)
    yyerrstatus--;

  /* Shift the lookahead token.  */
  YY_SYMBOL_PRINT ("Shifting", yytoken, &yylval, &yylloc);

  /* Discard the shifted token.  */
  yychar = YYEMPTY;

  yystate = yyn;
  YY_IGNORE_MAYBE_UNINITIALIZED_BEGIN
  *++yyvsp = yylval;
  YY_IGNORE_MAYBE_UNINITIALIZED_END

  goto yynewstate;


/*-----------------------------------------------------------.
| yydefault -- do the default action for the current state.  |
`-----------------------------------------------------------*/
yydefault:
  yyn = yydefact[yystate];
  if (yyn == 0)
    goto yyerrlab;
  goto yyreduce;


/*-----------------------------.
| yyreduce -- Do a reduction.  |
`-----------------------------*/
yyreduce:
  /* yyn is the number of a rule to reduce with.  */
  yylen = yyr2[yyn];

  /* If YYLEN is nonzero, implement the default value of the action:
     `$$ = $1'.

     Otherwise, the following line sets YYVAL to garbage.
     This behavior is undocumented and Bison
     users should not rely upon it.  Assigning to YYVAL
     unconditionally makes the parser a bit smaller, and it avoids a
     GCC warning that YYVAL may be used uninitialized.  */
  yyval = yyvsp[1-yylen];


  YY_REDUCE_PRINT (yyn);
  switch (yyn)
    {
        case 2:
/* Line 1787 of yacc.c  */
#line 147 "smtlib2.y"
    {
      EXPR = *(yyvsp[(2) - (3)].node);
      delete (yyvsp[(2) - (3)].node);
      YYACCEPT;
    }
    break;

  case 3:
/* Line 1787 of yacc.c  */
#line 153 "smtlib2.y"
    { 
      TMP->done = true;
      EXPR = CVC3::Expr();
      YYACCEPT;
    }
    break;

  case 4:
/* Line 1787 of yacc.c  */
#line 162 "smtlib2.y"
    {
      ARRAYSENABLED = false;
      BVENABLED = false;
      std::vector<CVC3::Expr> subCommands;

      /* Add the symbols of the core theory */
      subCommands.push_back( VC->listExpr("_TYPEDEF", VC->idExpr("Bool"),
                                          VC->idExpr("_BOOLEAN")) );
      subCommands.push_back( VC->listExpr("_CONST", VC->idExpr("true"),
                                          VC->idExpr("Bool"),
                                          VC->idExpr("_TRUE_EXPR")) );
      subCommands.push_back( VC->listExpr("_CONST", VC->idExpr("false"),
                                          VC->idExpr("Bool"),
                                          VC->idExpr("_FALSE_EXPR")) );

      if (*(yyvsp[(2) - (2)].str) == "QF_AX" ||
          *(yyvsp[(2) - (2)].str) == "QF_AUFLIA" ||
          *(yyvsp[(2) - (2)].str) == "AUFLIA" ||
          *(yyvsp[(2) - (2)].str) == "QF_AUFLIRA" ||
          *(yyvsp[(2) - (2)].str) == "AUFLIRA" ||
          *(yyvsp[(2) - (2)].str) == "QF_AUFNIRA" ||
          *(yyvsp[(2) - (2)].str) == "AUFNIRA" ||
          *(yyvsp[(2) - (2)].str) == "QF_AUFBV" ||
          *(yyvsp[(2) - (2)].str) == "QF_ABV") {
        ARRAYSENABLED = true;
      }

      if (*(yyvsp[(2) - (2)].str) == "QF_AUFBV" ||
          *(yyvsp[(2) - (2)].str) == "QF_ABV" ||
          *(yyvsp[(2) - (2)].str) == "QF_BV" ||
          *(yyvsp[(2) - (2)].str) == "QF_UFBV") {
        BVENABLED = true;
      }

      /* Add the Int type for logics that include it */
      if (*(yyvsp[(2) - (2)].str) == "AUFLIA" ||
          *(yyvsp[(2) - (2)].str) == "AUFLIRA" ||
          *(yyvsp[(2) - (2)].str) == "AUFNIRA" ||
          *(yyvsp[(2) - (2)].str) == "QF_AUFLIA" ||
          *(yyvsp[(2) - (2)].str) == "QF_IDL" ||
          *(yyvsp[(2) - (2)].str) == "QF_LIA" ||
          *(yyvsp[(2) - (2)].str) == "QF_NIA" ||
          *(yyvsp[(2) - (2)].str) == "QF_UFIDL" ||
          *(yyvsp[(2) - (2)].str) == "QF_UFLIA" ||
          *(yyvsp[(2) - (2)].str) == "UFNIA" ) {
        subCommands.push_back( VC->listExpr("_TYPEDEF", VC->idExpr("Int"),
                                            VC->idExpr("_INT")) );
      }

      /* Add the Real type for logics that include it */
      if (*(yyvsp[(2) - (2)].str) == "AUFLIRA" ||
          *(yyvsp[(2) - (2)].str) == "AUFNIRA" ||
          *(yyvsp[(2) - (2)].str) == "LRA" ||
          *(yyvsp[(2) - (2)].str) == "QF_RDL" ||
          *(yyvsp[(2) - (2)].str) == "QF_LRA" ||
          *(yyvsp[(2) - (2)].str) == "QF_NRA" ||
          *(yyvsp[(2) - (2)].str) == "QF_UFLRA" ||
          *(yyvsp[(2) - (2)].str) == "QF_UFNRA" ||
          *(yyvsp[(2) - (2)].str) == "UFLRA" ||
          *(yyvsp[(2) - (2)].str) == "QF_UFRDL" ) {
        subCommands.push_back( VC->listExpr("_TYPEDEF", VC->idExpr("Real"),
                                            VC->idExpr("_REAL")) );
      }

      /* Enable complete instantiation heuristics */
      if (*(yyvsp[(2) - (2)].str) == "AUFLIA" ||
          *(yyvsp[(2) - (2)].str) == "AUFLIRA" ||
          *(yyvsp[(2) - (2)].str) == "AUFNIRA" ||
          *(yyvsp[(2) - (2)].str) == "LRA" ||
          *(yyvsp[(2) - (2)].str) == "UFLRA" ||
          *(yyvsp[(2) - (2)].str) == "UFNIA") {
        subCommands.push_back( VC->listExpr("_OPTION", 
                                            VC->stringExpr("quant-complete-inst"), 
                                            VC->ratExpr(1)) );
      }

      (yyval.node) = new CVC3::Expr(VC->listExpr("_SEQ", subCommands));
      delete (yyvsp[(2) - (2)].str);
    }
    break;

  case 5:
/* Line 1787 of yacc.c  */
#line 243 "smtlib2.y"
    {
      (yyval.node) = NULL;
      if(*(yyvsp[(2) - (3)].str) == ":status") {
        TRANSLATOR->setStatus((*(yyvsp[(3) - (3)].node))[0].getString());
      } else if(*(yyvsp[(2) - (3)].str) == ":source") {
        if((yyvsp[(3) - (3)].node)->getKind() == CVC3::STRING_EXPR) {
          TRANSLATOR->setSource((yyvsp[(3) - (3)].node)->getString());
        } else if((yyvsp[(3) - (3)].node)->getKind() == CVC3::ID) {
          TRANSLATOR->setSource((*(yyvsp[(3) - (3)].node))[0].getString());
        } else {
          smtlib2error("bad type for set-info :source");
        }
      } else if(*(yyvsp[(2) - (3)].str) == ":category") {
        TRANSLATOR->setCategory((yyvsp[(3) - (3)].node)->getString());
      } else if(*(yyvsp[(2) - (3)].str) == ":notes") {
        std::string notes;
        if((yyvsp[(3) - (3)].node)->getKind() == CVC3::STRING_EXPR) {
          notes = (yyvsp[(3) - (3)].node)->getString();
        } else if((yyvsp[(3) - (3)].node)->getKind() == CVC3::ID) {
          notes = (*(yyvsp[(3) - (3)].node))[0].getString();
        } else {
          smtlib2error("bad type for set-info :notes");
        }
        (yyval.node) = new CVC3::Expr(VC->listExpr("_ANNOTATION", VC->listExpr(VC->stringExpr("notes"), VC->stringExpr(notes))));
      }
      delete (yyvsp[(2) - (3)].str);
      delete (yyvsp[(3) - (3)].node);
      if((yyval.node) == NULL) {
        (yyval.node) = new CVC3::Expr();
      }
    }
    break;

  case 6:
/* Line 1787 of yacc.c  */
#line 276 "smtlib2.y"
    {
      (yyval.node) = new CVC3::Expr(VC->listExpr("_TYPE", VC->idExpr(*(yyvsp[(2) - (3)].str))));
      delete (yyvsp[(2) - (3)].str);
    }
    break;

  case 7:
/* Line 1787 of yacc.c  */
#line 282 "smtlib2.y"
    {
      if ((yyvsp[(4) - (6)].vec)->size() == 0) {
        (yyval.node) = new CVC3::Expr(VC->listExpr("_CONST", VC->idExpr(*(yyvsp[(2) - (6)].str)), (*(yyvsp[(6) - (6)].node))));
      }
      else {
        (yyvsp[(4) - (6)].vec)->push_back( *(yyvsp[(6) - (6)].node) );
        CVC3::Expr tmp(VC->listExpr("_ARROW", *(yyvsp[(4) - (6)].vec)));
        (yyval.node) = new CVC3::Expr(VC->listExpr("_CONST", VC->idExpr(*(yyvsp[(2) - (6)].str)), tmp));
      }
      delete (yyvsp[(2) - (6)].str);
      delete (yyvsp[(4) - (6)].vec);
      delete (yyvsp[(6) - (6)].node);
    }
    break;

  case 8:
/* Line 1787 of yacc.c  */
#line 297 "smtlib2.y"
    {
      (yyval.node) = new CVC3::Expr(VC->listExpr("_ASSERT", *(yyvsp[(2) - (2)].node)));
      delete (yyvsp[(2) - (2)].node);
    }
    break;

  case 9:
/* Line 1787 of yacc.c  */
#line 303 "smtlib2.y"
    {
      (yyval.node) = new CVC3::Expr(VC->listExpr("_CHECKSAT",
                                       CVC3::Expr(VC->idExpr("_TRUE_EXPR"))));
    }
    break;

  case 10:
/* Line 1787 of yacc.c  */
#line 309 "smtlib2.y"
    {
      (yyval.node) = new CVC3::Expr(VC->listExpr("_PUSH", CVC3::Expr(VC->ratExpr((*(yyvsp[(2) - (2)].str))))));
    }
    break;

  case 11:
/* Line 1787 of yacc.c  */
#line 314 "smtlib2.y"
    {
      (yyval.node) = new CVC3::Expr(VC->listExpr("_POP", CVC3::Expr(VC->ratExpr((*(yyvsp[(2) - (2)].str))))));
    }
    break;

  case 12:
/* Line 1787 of yacc.c  */
#line 319 "smtlib2.y"
    {
      (yyval.node) = new CVC3::Expr(VC->listExpr(VC->idExpr("_DUMP_PROOF")));
    }
    break;

  case 13:
/* Line 1787 of yacc.c  */
#line 324 "smtlib2.y"
    {
      (yyval.node) = new CVC3::Expr(VC->listExpr(VC->idExpr("_GET_ASSIGNMENT")));
    }
    break;

  case 14:
/* Line 1787 of yacc.c  */
#line 329 "smtlib2.y"
    {
      (yyval.node) = new CVC3::Expr(VC->listExpr(VC->idExpr("_GET_VALUE"), VC->listExpr(*(yyvsp[(3) - (4)].vec))));
      delete (yyvsp[(3) - (4)].vec);
    }
    break;

  case 15:
/* Line 1787 of yacc.c  */
#line 335 "smtlib2.y"
    {
      (yyval.node) = new CVC3::Expr(VC->listExpr(VC->idExpr("_COUNTERMODEL")));
    }
    break;

  case 16:
/* Line 1787 of yacc.c  */
#line 340 "smtlib2.y"
    {
      TMP->done = true;
      (yyval.node) = new CVC3::Expr();
    }
    break;

  case 17:
/* Line 1787 of yacc.c  */
#line 348 "smtlib2.y"
    {
      (yyval.vec) = new std::vector<CVC3::Expr>;
      (yyval.vec)->push_back(*(yyvsp[(1) - (1)].node));
      delete (yyvsp[(1) - (1)].node);
    }
    break;

  case 18:
/* Line 1787 of yacc.c  */
#line 354 "smtlib2.y"
    { 
      (yyvsp[(1) - (2)].vec)->push_back(*(yyvsp[(2) - (2)].node));
      (yyval.vec) = (yyvsp[(1) - (2)].vec);
      delete (yyvsp[(2) - (2)].node);
    }
    break;

  case 19:
/* Line 1787 of yacc.c  */
#line 366 "smtlib2.y"
    { (yyval.node) = new CVC3::Expr(VC->ratExpr(*(yyvsp[(1) - (1)].str))); 
      delete (yyvsp[(1) - (1)].str); }
    break;

  case 20:
/* Line 1787 of yacc.c  */
#line 369 "smtlib2.y"
    {
      (yyval.node) = new CVC3::Expr(VC->ratExpr(*(yyvsp[(1) - (1)].str))); 
      if(VC->getFlags()["translate"].getBool() && (yyvsp[(1) - (1)].str)->find('.') != std::string::npos) {
        CVC3::Expr* e = (yyval.node);
        (yyval.node) = new CVC3::Expr(CVC3::REAL_CONST, *e);
        delete e;
      }
      delete (yyvsp[(1) - (1)].str);
    }
    break;

  case 21:
/* Line 1787 of yacc.c  */
#line 379 "smtlib2.y"
    { (yyval.node) = new CVC3::Expr(VC->stringExpr(*(yyvsp[(1) - (1)].str))); 
      delete (yyvsp[(1) - (1)].str);}
    break;

  case 22:
/* Line 1787 of yacc.c  */
#line 382 "smtlib2.y"
    { (yyval.node) = new CVC3::Expr(VC->idExpr(*(yyvsp[(1) - (1)].str))); 
      delete (yyvsp[(1) - (1)].str);}
    break;

  case 23:
/* Line 1787 of yacc.c  */
#line 385 "smtlib2.y"
    { (yyval.node) = new CVC3::Expr(VC->listExpr(*(yyvsp[(2) - (3)].vec))); 
      delete (yyvsp[(2) - (3)].vec); }
    break;

  case 24:
/* Line 1787 of yacc.c  */
#line 391 "smtlib2.y"
    {
      (yyval.node) = (yyvsp[(1) - (1)].node);
    }
    break;

  case 25:
/* Line 1787 of yacc.c  */
#line 395 "smtlib2.y"
    { (yyval.node) = new CVC3::Expr(VC->idExpr(*(yyvsp[(1) - (1)].str))); 
      delete (yyvsp[(1) - (1)].str);}
    break;

  case 26:
/* Line 1787 of yacc.c  */
#line 401 "smtlib2.y"
    {
      (yyval.vec) = new std::vector<CVC3::Expr>;
    }
    break;

  case 27:
/* Line 1787 of yacc.c  */
#line 405 "smtlib2.y"
    { 
      (yyval.vec) = (yyvsp[(1) - (1)].vec);
    }
    break;

  case 28:
/* Line 1787 of yacc.c  */
#line 412 "smtlib2.y"
    {
      (yyval.vec) = new std::vector<CVC3::Expr>;
      (yyval.vec)->push_back(*(yyvsp[(1) - (1)].node));
      delete (yyvsp[(1) - (1)].node);
    }
    break;

  case 29:
/* Line 1787 of yacc.c  */
#line 418 "smtlib2.y"
    { 
      (yyvsp[(1) - (2)].vec)->push_back(*(yyvsp[(2) - (2)].node));
      (yyval.vec) = (yyvsp[(1) - (2)].vec);
      delete (yyvsp[(2) - (2)].node);
    }
    break;

  case 30:
/* Line 1787 of yacc.c  */
#line 427 "smtlib2.y"
    { 
      CVC3::Expr id = *(yyvsp[(1) - (1)].node);
      if( BVENABLED &&
          id.isRawList() &&
          id[0].getKind() == CVC3::ID &&
          id[0][0].getString() == "BitVec" &&
          id.arity() == 2 &&
          id[1].isRational() ) {
        (yyval.node) = new CVC3::Expr( VC->listExpr("_BITVECTOR", id[1]) );
        delete (yyvsp[(1) - (1)].node);
      } else {
        (yyval.node) = (yyvsp[(1) - (1)].node);
      }
    }
    break;

  case 31:
/* Line 1787 of yacc.c  */
#line 442 "smtlib2.y"
    {
      CVC3::Expr id = *(yyvsp[(2) - (4)].node);
      if (ARRAYSENABLED && 
          id.getKind() == CVC3::ID &&
          id[0].getString() == "Array" 
          && (yyvsp[(3) - (4)].vec)->size() == 2) {
        (yyval.node) = new CVC3::Expr( VC->listExpr("_ARRAY", *(yyvsp[(3) - (4)].vec)) );
      } else {
        // FIXME: How to handle non-array parameterized types?
        (yyvsp[(3) - (4)].vec)->insert( (yyvsp[(3) - (4)].vec)->begin(), *(yyvsp[(2) - (4)].node) );
        (yyval.node) = new CVC3::Expr( VC->listExpr(*(yyvsp[(3) - (4)].vec)) );
      }
      delete (yyvsp[(2) - (4)].node);
      delete (yyvsp[(3) - (4)].vec);
    }
    break;

  case 32:
/* Line 1787 of yacc.c  */
#line 461 "smtlib2.y"
    {
      std::string id = *(yyvsp[(1) - (1)].str);
      /* If the id is a built-in operator, replace the text with the 
         internal name. 

         NOTE: the right way to do this would be would be with a 
         hash_map or trie.
      */
      if (id == "and") {
        id = "_AND";
      } else if (id == "distinct") {
        id = "_DISTINCT";
      } else if (id == "ite") {
        id = "_IF";
      } else if (id == "/") {
        id = "_DIVIDE";
      } else if (id == "=") {
        id = "_EQ";
      } else if (id == ">") {
        id = "_GT";
      } else if (id == ">=") {
        id = "_GE";
      } else if (id == "=>") {
        id = "_IMPLIES";
      } else if (id == "<") {
        id = "_LT";
      } else if (id == "<=") {
        id = "_LE";
      } else if (id == "-") {
        id = "_MINUS";
      } else if (id == "not") {
        id = "_NOT";
      } else if (id == "or") {
        id = "_OR";
      } else if (id == "+") {
        id = "_PLUS";
      } else if (id == "*") {
        id = "_MULT";
      } else if (id == "is_int") {
        id = "_IS_INTEGER";
      } else if (id == "xor") {
        id = "_XOR";
      } else if (ARRAYSENABLED && id == "select") {
          id = "_READ";
      } else if (ARRAYSENABLED && id == "store") {
        id = "_WRITE";
      } else if (BVENABLED && id == "concat") {
        id = "_CONCAT";
      } else if (BVENABLED && id == "bvadd") {
        id = "_BVPLUS";
      } else if (BVENABLED && id == "bvand") {
        id = "_BVAND";
      } else if (BVENABLED && id == "bvashr") {
        id = "_BVASHR";
      } else if (BVENABLED && id == "bvcomp") {
        id = "_BVCOMP";
      } else if (BVENABLED && id == "bvlshr") {
        id = "_BVLSHR";
      } else if (BVENABLED && id == "bvmul") {
        id = "_BVMULT";
      } else if (BVENABLED && id == "bvneg") {
        id = "_BVUMINUS";
      } else if (BVENABLED && id == "bvnand") {
        id = "_BVNAND";
      } else if (BVENABLED && id == "bvnot") {
        id = "_BVNEG";
      } else if (BVENABLED && id == "bvnor") {
        id = "_BVNOR";
      } else if (BVENABLED && id == "bvor") {
        id = "_BVOR";
      } else if (BVENABLED && id == "bvshl") {
        id = "_BVSHL";
      } else if (BVENABLED && id == "bvsdiv") {
        id = "_BVSDIV";
      } else if (BVENABLED && id == "bvsge") {
        id = "_BVSGE";
      } else if (BVENABLED && id == "bvsgt") {
        id = "_BVSGT";
      } else if (BVENABLED && id == "bvsle") {
        id = "_BVSLE";
      } else if (BVENABLED && id == "bvslt") {
        id = "_BVSLT";
      } else if (BVENABLED && id == "bvsmod") {
        id = "_BVSMOD";
      } else if (BVENABLED && id == "bvsrem") {
        id = "_BVSREM";
      } else if (BVENABLED && id == "bvsub") {
        id = "_BVSUB";
      } else if (BVENABLED && id == "bvudiv") {
        id = "_BVUDIV";
      } else if (BVENABLED && id == "bvuge") {
        id = "_BVGE";
      } else if (BVENABLED && id == "bvugt") {
        id = "_BVGT";
      } else if (BVENABLED && id == "bvule") {
        id = "_BVLE";
      } else if (BVENABLED && id == "bvult") {
        id = "_BVLT";
      } else if (BVENABLED && id == "bvurem") {
        id = "_BVUREM";
      } else if (BVENABLED && id == "bvxnor") {
        id = "_BVXNOR";
      } else if (BVENABLED && id == "bvxor") {
        id = "_BVXOR";
      } 
      (yyval.node) = new CVC3::Expr( VC->idExpr( id ) );
      delete (yyvsp[(1) - (1)].str);
    }
    break;

  case 33:
/* Line 1787 of yacc.c  */
#line 570 "smtlib2.y"
    {
      std::string id = *(yyvsp[(3) - (5)].str);
      std::vector<CVC3::Expr> numerals = *(yyvsp[(4) - (5)].vec);
      if (BVENABLED &&
          id.size() > 2 &&
          id[0] == 'b' &&
          id[1] == 'v' &&
          numerals.size() == 1) {
        DebugAssert( numerals[0].isRational() &&
                     numerals[0].getRational().isInteger(),
                     "Illegal size argument to bit-vector constant." );
        (yyval.node) = new CVC3::Expr( VC->listExpr("_BVCONST",
                                          VC->ratExpr(id.substr(2), 10),
                                          (*(yyvsp[(4) - (5)].vec))[0]) );
      } else {
        if (BVENABLED && id == "extract") {
          id = "_EXTRACT";
        } else if (BVENABLED && id == "repeat") {
          id = "_BVREPEAT";
        } else if (BVENABLED && id == "zero_extend") {
          id = "_BVZEROEXTEND";
        } else if (BVENABLED && id == "sign_extend") {
          id = "_SX";
        } else if (BVENABLED && id == "rotate_left") {
          id = "_BVROTL";
        } else if (BVENABLED && id == "rotate_right") {
          id = "_BVROTR";
        }
        (yyval.node) = new CVC3::Expr( VC->listExpr( id, *(yyvsp[(4) - (5)].vec) ) );
      }
      delete (yyvsp[(3) - (5)].str);
      delete (yyvsp[(4) - (5)].vec);
    }
    break;

  case 34:
/* Line 1787 of yacc.c  */
#line 608 "smtlib2.y"
    {
      (yyval.vec) = new std::vector<CVC3::Expr>;
      (yyval.vec)->push_back( VC->ratExpr(*(yyvsp[(1) - (1)].str)) );
      delete (yyvsp[(1) - (1)].str);
    }
    break;

  case 35:
/* Line 1787 of yacc.c  */
#line 614 "smtlib2.y"
    {
      (yyvsp[(1) - (2)].vec)->push_back( VC->ratExpr(*(yyvsp[(2) - (2)].str)) );
      (yyval.vec) = (yyvsp[(1) - (2)].vec);
      delete (yyvsp[(2) - (2)].str);
    }
    break;

  case 36:
/* Line 1787 of yacc.c  */
#line 624 "smtlib2.y"
    {
      (yyval.vec) = new std::vector<CVC3::Expr>;
      (yyval.vec)->push_back(*(yyvsp[(1) - (1)].node));
      delete (yyvsp[(1) - (1)].node);
    }
    break;

  case 37:
/* Line 1787 of yacc.c  */
#line 631 "smtlib2.y"
    {
      (yyvsp[(1) - (2)].vec)->push_back(*(yyvsp[(2) - (2)].node));
      (yyval.vec) = (yyvsp[(1) - (2)].vec);
      delete (yyvsp[(2) - (2)].node);
    }
    break;

  case 38:
/* Line 1787 of yacc.c  */
#line 640 "smtlib2.y"
    {
      CVC3::Expr op = *(yyvsp[(2) - (4)].node);
      std::vector<CVC3::Expr> args = *(yyvsp[(3) - (4)].vec);

      std::vector<CVC3::Expr> resultList;

      bool isId = op.getKind() == CVC3::ID;
      std::string opStr;
      if( isId ) {
        opStr = op[0].getString();
      }
      
      if( isId && opStr == "_MINUS" && args.size() == 1 ) {
        resultList.push_back( VC->idExpr("_UMINUS") );
        resultList.push_back( args[0] );
      } else if( isId &&
                 ( opStr == "_AND" ||
                   opStr == "_OR" ||
                   opStr == "_XOR" ||
                   opStr == "_PLUS" ||
                   opStr == "_MULT" ) &&
                 args.size() == 1 ) {
        smtlib2error("[bin,N]-ary operator used in unary context");
      } else {
        const int arity = op.arity();
        isId = arity > 0 && op[0].getKind() == CVC3::ID;
        if( isId ) {
          opStr = op[0][0].getString();
        }

        if( BVENABLED && arity == 3 && isId &&
            opStr == "_EXTRACT" &&
            op[1].isRational() &&
            op[1].getRational().isInteger() && 
            op[2].isRational() &&
            op[2].getRational().isInteger() ) {
          resultList.push_back( op[0] );
          resultList.push_back(op[1]);
          resultList.push_back(op[2]);
        } else if( BVENABLED && arity == 2 && isId && 
                   ( opStr == "_BVREPEAT" ||
                     opStr == "_BVZEROEXTEND" ||
                     opStr == "_BVROTL" ||
                     opStr == "_BVROTR" ||
                     opStr == "_SX" ) &&
                   op[1].isRational() &&
                   op[1].getRational().isInteger() ) {
          resultList.push_back( op[0] );
          if( opStr == "_SX" ) {
            resultList.push_back(VC->idExpr("_smtlib"));
          }
          resultList.push_back(op[1]);
        } else {
          resultList.push_back(op);
        } 

        resultList.insert( resultList.end(), args.begin(), args.end() );
      } 

      (yyval.node) = new CVC3::Expr(VC->listExpr(resultList));
      delete (yyvsp[(2) - (4)].node);
      delete (yyvsp[(3) - (4)].vec);
    }
    break;

  case 39:
/* Line 1787 of yacc.c  */
#line 705 "smtlib2.y"
    {
      CVC3::Expr e(VC->listExpr(*(yyvsp[(4) - (7)].vec)));
      (yyval.node) = new CVC3::Expr(VC->listExpr("_LET", e, *(yyvsp[(6) - (7)].node)));
      delete (yyvsp[(4) - (7)].vec);
      delete (yyvsp[(6) - (7)].node);
    }
    break;

  case 40:
/* Line 1787 of yacc.c  */
#line 713 "smtlib2.y"
    {
      CVC3::Expr e(VC->listExpr(*(yyvsp[(4) - (7)].vec)));
      CVC3::Expr body(*(yyvsp[(6) - (7)].node));
      DebugAssert( body.arity() > 0, "Empty quantifier body." );
      if( body[0].isString() && 
          body[0].getString() == "_ANNOTATION" ) {
        CVC3::Expr annots = body[2];
        body = body[1]; // real body, stripping annot wrapper
        std::vector<CVC3::Expr> patterns;
        for( int i = 0; i < annots.arity(); ++i ) {
          DebugAssert( annots[i].arity() == 2 &&
                       annots[i][0].getKind() == CVC3::ID,
                       "Illegal annotation." );
          if( annots[i][0][0].getString() == ":pattern" ) {
            patterns.push_back( annots[i][1] );
          }
        }
        (yyval.node) = new CVC3::Expr(VC->listExpr(*(yyvsp[(2) - (7)].str), e, body, VC->listExpr(patterns)));
      } else {
        (yyval.node) = new CVC3::Expr(VC->listExpr(*(yyvsp[(2) - (7)].str), e, body));
      }
      delete (yyvsp[(2) - (7)].str);
      delete (yyvsp[(4) - (7)].vec);
      delete (yyvsp[(6) - (7)].node);
    }
    break;

  case 41:
/* Line 1787 of yacc.c  */
#line 740 "smtlib2.y"
    {
      (yyval.node) = new CVC3::Expr(VC->listExpr(VC->stringExpr("_ANNOTATION"), 
                                       *(yyvsp[(3) - (5)].node), 
                                       VC->listExpr(*(yyvsp[(4) - (5)].vec))));
      delete (yyvsp[(3) - (5)].node);
      delete (yyvsp[(4) - (5)].vec);
    }
    break;

  case 42:
/* Line 1787 of yacc.c  */
#line 749 "smtlib2.y"
    {
      (yyval.node) = (yyvsp[(1) - (1)].node);
    }
    break;

  case 43:
/* Line 1787 of yacc.c  */
#line 754 "smtlib2.y"
    {
      (yyval.node) = new CVC3::Expr(VC->ratExpr(*(yyvsp[(1) - (1)].str)));
      if(VC->getFlags()["translate"].getBool() && (yyvsp[(1) - (1)].str)->find('.') != std::string::npos) {
        CVC3::Expr* e = (yyval.node);
        (yyval.node) = new CVC3::Expr(CVC3::REAL_CONST, *e);
        delete e;
      }
      delete (yyvsp[(1) - (1)].str);
    }
    break;

  case 44:
/* Line 1787 of yacc.c  */
#line 765 "smtlib2.y"
    {
      (yyval.node) = new CVC3::Expr(VC->ratExpr(*(yyvsp[(1) - (1)].str)));
      delete (yyvsp[(1) - (1)].str);
    }
    break;

  case 45:
/* Line 1787 of yacc.c  */
#line 771 "smtlib2.y"
    {
      std::vector<CVC3::Expr> args;
      args.push_back(VC->idExpr("_BVCONST"));
      args.push_back(VC->ratExpr(*(yyvsp[(1) - (1)].str), 16));
      args.push_back(VC->ratExpr(4 * (yyvsp[(1) - (1)].str)->length()));
      (yyval.node) = new CVC3::Expr(VC->listExpr(args));
      delete (yyvsp[(1) - (1)].str);
    }
    break;

  case 46:
/* Line 1787 of yacc.c  */
#line 781 "smtlib2.y"
    {
      std::vector<CVC3::Expr> args;
      args.push_back(VC->idExpr("_BVCONST"));
      args.push_back(VC->ratExpr(*(yyvsp[(1) - (1)].str), 2));
      args.push_back(VC->ratExpr((yyvsp[(1) - (1)].str)->length()));
      (yyval.node) = new CVC3::Expr(VC->listExpr(args));
      delete (yyvsp[(1) - (1)].str);
    }
    break;

  case 47:
/* Line 1787 of yacc.c  */
#line 948 "smtlib2.y"
    {
      (yyval.str) = new std::string("_EXISTS");
    }
    break;

  case 48:
/* Line 1787 of yacc.c  */
#line 952 "smtlib2.y"
    {
      (yyval.str) = new std::string("_FORALL");
    }
    break;

  case 49:
/* Line 1787 of yacc.c  */
#line 961 "smtlib2.y"
    { 
      (yyval.vec) = new std::vector<CVC3::Expr>;
      (yyval.vec)->push_back(*(yyvsp[(1) - (1)].node));
      delete (yyvsp[(1) - (1)].node); 
    }
    break;

  case 50:
/* Line 1787 of yacc.c  */
#line 967 "smtlib2.y"
    {
      (yyvsp[(1) - (2)].vec)->push_back(*(yyvsp[(2) - (2)].node));
      (yyval.vec) = (yyvsp[(1) - (2)].vec);
      delete (yyvsp[(2) - (2)].node);
    }
    break;

  case 51:
/* Line 1787 of yacc.c  */
#line 976 "smtlib2.y"
    { (yyval.node) = new CVC3::Expr( VC->listExpr(*(yyvsp[(2) - (4)].str), *(yyvsp[(3) - (4)].node)) );
      delete (yyvsp[(2) - (4)].str);
      delete (yyvsp[(3) - (4)].node); }
    break;

  case 52:
/* Line 1787 of yacc.c  */
#line 984 "smtlib2.y"
    {
      (yyval.vec) = new std::vector<CVC3::Expr>;
      (yyval.vec)->push_back(*(yyvsp[(1) - (1)].node));
      delete (yyvsp[(1) - (1)].node);
    }
    break;

  case 53:
/* Line 1787 of yacc.c  */
#line 990 "smtlib2.y"
    {
      (yyvsp[(1) - (2)].vec)->push_back(*(yyvsp[(2) - (2)].node));
      (yyval.vec) = (yyvsp[(1) - (2)].vec); 
      delete (yyvsp[(2) - (2)].node);
    }
    break;

  case 54:
/* Line 1787 of yacc.c  */
#line 999 "smtlib2.y"
    {
      (yyval.node) = new CVC3::Expr(VC->listExpr(*(yyvsp[(2) - (4)].str), *(yyvsp[(3) - (4)].node)));
      delete (yyvsp[(2) - (4)].str);
      delete (yyvsp[(3) - (4)].node);
    }
    break;

  case 55:
/* Line 1787 of yacc.c  */
#line 1009 "smtlib2.y"
    {
      (yyval.vec) = new std::vector<CVC3::Expr>;
      (yyval.vec)->push_back( *(yyvsp[(1) - (1)].node) );
      delete (yyvsp[(1) - (1)].node);
    }
    break;

  case 56:
/* Line 1787 of yacc.c  */
#line 1015 "smtlib2.y"
    {
      (yyvsp[(1) - (2)].vec)->push_back( *(yyvsp[(2) - (2)].node) );
      (yyval.vec) = (yyvsp[(1) - (2)].vec);
      delete (yyvsp[(2) - (2)].node);
    }
    break;

  case 57:
/* Line 1787 of yacc.c  */
#line 1024 "smtlib2.y"
    {
      (yyval.node) = new CVC3::Expr( VC->idExpr(*(yyvsp[(1) - (1)].str)) );
      delete (yyvsp[(1) - (1)].str);
    }
    break;

  case 58:
/* Line 1787 of yacc.c  */
#line 1030 "smtlib2.y"
    {
      (yyval.node) = new CVC3::Expr( VC->listExpr( VC->idExpr(*(yyvsp[(1) - (2)].str)), VC->idExpr(*(yyvsp[(2) - (2)].str)) ) );
      delete (yyvsp[(1) - (2)].str);
      delete (yyvsp[(2) - (2)].str);
    }
    break;

  case 59:
/* Line 1787 of yacc.c  */
#line 1037 "smtlib2.y"
    {
      (yyval.node) = new CVC3::Expr( VC->listExpr( VC->idExpr(*(yyvsp[(1) - (2)].str)), VC->ratExpr(*(yyvsp[(2) - (2)].str)) ) );
      delete (yyvsp[(1) - (2)].str);
      delete (yyvsp[(2) - (2)].str);
    }
    break;

  case 60:
/* Line 1787 of yacc.c  */
#line 1044 "smtlib2.y"
    {
      (yyval.node) = new CVC3::Expr( VC->listExpr( VC->idExpr(*(yyvsp[(1) - (2)].str)), VC->ratExpr(*(yyvsp[(2) - (2)].str)) ) );
      delete (yyvsp[(1) - (2)].str);
      delete (yyvsp[(2) - (2)].str);
    }
    break;

  case 61:
/* Line 1787 of yacc.c  */
#line 1051 "smtlib2.y"
    {
      (yyval.node) = new CVC3::Expr( VC->listExpr( VC->idExpr(*(yyvsp[(1) - (2)].str)), VC->ratExpr(*(yyvsp[(2) - (2)].str), 16) ) );
      delete (yyvsp[(1) - (2)].str);
      delete (yyvsp[(2) - (2)].str);
    }
    break;

  case 62:
/* Line 1787 of yacc.c  */
#line 1058 "smtlib2.y"
    {
      (yyval.node) = new CVC3::Expr( VC->listExpr( VC->idExpr(*(yyvsp[(1) - (2)].str)), VC->ratExpr(*(yyvsp[(2) - (2)].str), 2) ) );
      delete (yyvsp[(1) - (2)].str);
      delete (yyvsp[(2) - (2)].str);
    }
    break;

  case 63:
/* Line 1787 of yacc.c  */
#line 1065 "smtlib2.y"
    {
      (yyval.node) = new CVC3::Expr( VC->listExpr( VC->idExpr(*(yyvsp[(1) - (2)].str)), VC->stringExpr(*(yyvsp[(2) - (2)].str)) ) );
      delete (yyvsp[(1) - (2)].str);
      delete (yyvsp[(2) - (2)].str);
    }
    break;

  case 64:
/* Line 1787 of yacc.c  */
#line 1072 "smtlib2.y"
    {
      // was "non_keyword_sexpr" above instead of "(terms)", but that breaks :pattern
      (yyval.node) = new CVC3::Expr( VC->listExpr( VC->idExpr(*(yyvsp[(1) - (4)].str)), VC->listExpr(*(yyvsp[(3) - (4)].vec)) ) );
      delete (yyvsp[(1) - (4)].str);
      delete (yyvsp[(3) - (4)].vec);
    }
    break;


/* Line 1787 of yacc.c  */
#line 2519 "parsesmtlib2.cpp"
      default: break;
    }
  /* User semantic actions sometimes alter yychar, and that requires
     that yytoken be updated with the new translation.  We take the
     approach of translating immediately before every use of yytoken.
     One alternative is translating here after every semantic action,
     but that translation would be missed if the semantic action invokes
     YYABORT, YYACCEPT, or YYERROR immediately after altering yychar or
     if it invokes YYBACKUP.  In the case of YYABORT or YYACCEPT, an
     incorrect destructor might then be invoked immediately.  In the
     case of YYERROR or YYBACKUP, subsequent parser actions might lead
     to an incorrect destructor call or verbose syntax error message
     before the lookahead is translated.  */
  YY_SYMBOL_PRINT ("-> $$ =", yyr1[yyn], &yyval, &yyloc);

  YYPOPSTACK (yylen);
  yylen = 0;
  YY_STACK_PRINT (yyss, yyssp);

  *++yyvsp = yyval;

  /* Now `shift' the result of the reduction.  Determine what state
     that goes to, based on the state we popped back to and the rule
     number reduced by.  */

  yyn = yyr1[yyn];

  yystate = yypgoto[yyn - YYNTOKENS] + *yyssp;
  if (0 <= yystate && yystate <= YYLAST && yycheck[yystate] == *yyssp)
    yystate = yytable[yystate];
  else
    yystate = yydefgoto[yyn - YYNTOKENS];

  goto yynewstate;


/*------------------------------------.
| yyerrlab -- here on detecting error |
`------------------------------------*/
yyerrlab:
  /* Make sure we have latest lookahead translation.  See comments at
     user semantic actions for why this is necessary.  */
  yytoken = yychar == YYEMPTY ? YYEMPTY : YYTRANSLATE (yychar);

  /* If not already recovering from an error, report this error.  */
  if (!yyerrstatus)
    {
      ++yynerrs;
#if ! YYERROR_VERBOSE
      yyerror (YY_("syntax error"));
#else
# define YYSYNTAX_ERROR yysyntax_error (&yymsg_alloc, &yymsg, \
                                        yyssp, yytoken)
      {
        char const *yymsgp = YY_("syntax error");
        int yysyntax_error_status;
        yysyntax_error_status = YYSYNTAX_ERROR;
        if (yysyntax_error_status == 0)
          yymsgp = yymsg;
        else if (yysyntax_error_status == 1)
          {
            if (yymsg != yymsgbuf)
              YYSTACK_FREE (yymsg);
            yymsg = (char *) YYSTACK_ALLOC (yymsg_alloc);
            if (!yymsg)
              {
                yymsg = yymsgbuf;
                yymsg_alloc = sizeof yymsgbuf;
                yysyntax_error_status = 2;
              }
            else
              {
                yysyntax_error_status = YYSYNTAX_ERROR;
                yymsgp = yymsg;
              }
          }
        yyerror (yymsgp);
        if (yysyntax_error_status == 2)
          goto yyexhaustedlab;
      }
# undef YYSYNTAX_ERROR
#endif
    }



  if (yyerrstatus == 3)
    {
      /* If just tried and failed to reuse lookahead token after an
	 error, discard it.  */

      if (yychar <= YYEOF)
	{
	  /* Return failure if at end of input.  */
	  if (yychar == YYEOF)
	    YYABORT;
	}
      else
	{
	  yydestruct ("Error: discarding",
		      yytoken, &yylval);
	  yychar = YYEMPTY;
	}
    }

  /* Else will try to reuse lookahead token after shifting the error
     token.  */
  goto yyerrlab1;


/*---------------------------------------------------.
| yyerrorlab -- error raised explicitly by YYERROR.  |
`---------------------------------------------------*/
yyerrorlab:

  /* Pacify compilers like GCC when the user code never invokes
     YYERROR and the label yyerrorlab therefore never appears in user
     code.  */
  if (/*CONSTCOND*/ 0)
     goto yyerrorlab;

  /* Do not reclaim the symbols of the rule which action triggered
     this YYERROR.  */
  YYPOPSTACK (yylen);
  yylen = 0;
  YY_STACK_PRINT (yyss, yyssp);
  yystate = *yyssp;
  goto yyerrlab1;


/*-------------------------------------------------------------.
| yyerrlab1 -- common code for both syntax error and YYERROR.  |
`-------------------------------------------------------------*/
yyerrlab1:
  yyerrstatus = 3;	/* Each real token shifted decrements this.  */

  for (;;)
    {
      yyn = yypact[yystate];
      if (!yypact_value_is_default (yyn))
	{
	  yyn += YYTERROR;
	  if (0 <= yyn && yyn <= YYLAST && yycheck[yyn] == YYTERROR)
	    {
	      yyn = yytable[yyn];
	      if (0 < yyn)
		break;
	    }
	}

      /* Pop the current state because it cannot handle the error token.  */
      if (yyssp == yyss)
	YYABORT;


      yydestruct ("Error: popping",
		  yystos[yystate], yyvsp);
      YYPOPSTACK (1);
      yystate = *yyssp;
      YY_STACK_PRINT (yyss, yyssp);
    }

  YY_IGNORE_MAYBE_UNINITIALIZED_BEGIN
  *++yyvsp = yylval;
  YY_IGNORE_MAYBE_UNINITIALIZED_END


  /* Shift the error token.  */
  YY_SYMBOL_PRINT ("Shifting", yystos[yyn], yyvsp, yylsp);

  yystate = yyn;
  goto yynewstate;


/*-------------------------------------.
| yyacceptlab -- YYACCEPT comes here.  |
`-------------------------------------*/
yyacceptlab:
  yyresult = 0;
  goto yyreturn;

/*-----------------------------------.
| yyabortlab -- YYABORT comes here.  |
`-----------------------------------*/
yyabortlab:
  yyresult = 1;
  goto yyreturn;

#if !defined yyoverflow || YYERROR_VERBOSE
/*-------------------------------------------------.
| yyexhaustedlab -- memory exhaustion comes here.  |
`-------------------------------------------------*/
yyexhaustedlab:
  yyerror (YY_("memory exhausted"));
  yyresult = 2;
  /* Fall through.  */
#endif

yyreturn:
  if (yychar != YYEMPTY)
    {
      /* Make sure we have latest lookahead translation.  See comments at
         user semantic actions for why this is necessary.  */
      yytoken = YYTRANSLATE (yychar);
      yydestruct ("Cleanup: discarding lookahead",
                  yytoken, &yylval);
    }
  /* Do not reclaim the symbols of the rule which action triggered
     this YYABORT or YYACCEPT.  */
  YYPOPSTACK (yylen);
  YY_STACK_PRINT (yyss, yyssp);
  while (yyssp != yyss)
    {
      yydestruct ("Cleanup: popping",
		  yystos[*yyssp], yyvsp);
      YYPOPSTACK (1);
    }
#ifndef yyoverflow
  if (yyss != yyssa)
    YYSTACK_FREE (yyss);
#endif
#if YYERROR_VERBOSE
  if (yymsg != yymsgbuf)
    YYSTACK_FREE (yymsg);
#endif
  /* Make sure YYID is used.  */
  return YYID (yyresult);
}


/* Line 2050 of yacc.c  */
#line 1079 "smtlib2.y"

